"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Text = _interopRequireDefault(require("./Text"));

var _Tooltip = _interopRequireDefault(require("./Tooltip"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  large: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  square: _propTypes.default.string,
  segments: _propTypes.default.array,
  showItems: _propTypes.default.number
});

var BoxGroup = function BoxGroup(_ref) {
  var css = _ref.css,
      large = _ref.large,
      micro = _ref.micro,
      small = _ref.small,
      square = _ref.square,
      styles = _ref.styles,
      segments = _ref.segments,
      _ref$showItems = _ref.showItems,
      showItems = _ref$showItems === void 0 ? 4 : _ref$showItems;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.container), /*#__PURE__*/_react.default.createElement("div", css(styles.row), segments.filter(function (segment, count) {
    return count < showItems;
  }).map(function (segment) {
    return /*#__PURE__*/_react.default.createElement("div", css(styles.subitens), /*#__PURE__*/_react.default.createElement("div", css(styles.box, square && styles.squareBox, micro && styles.box_micro, small && styles.box_small, large && styles.box_large, !micro && !small && !large && styles.box_medium), segment.name));
  })), segments.length > showItems && /*#__PURE__*/_react.default.createElement("div", css(styles.others), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    bottom: true,
    text: segments.filter(function (segment, count) {
      return count >= showItems;
    }).map(function (segment, count) {
      return /*#__PURE__*/_react.default.createElement(_Text.default, {
        key: segment ? segment.name : count,
        micro: true,
        center: true,
        inverse: true,
        truncate: true
      }, segment && segment.name);
    })
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    muted: true,
    bold: true
  }, "+".concat(segments.length - showItems)))));
};

BoxGroup.propTypes = propTypes;
var BoxGroupWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      radius = _ref2.radius;
  return {
    container: {
      display: 'flex',
      alignItems: 'center'
    },
    row: {
      display: 'flex',
      alignItems: 'center',
      width: '100%',
      maxWidth: units(20),
      height: units(6),
      overflowY: "auto",
      flexWrap: "wrap"
    },
    subitens: {
      flexBasis: '50%'
    },
    box: {
      backgroundColor: color.secondary,
      boxShadow: '3px 3px 3px -1px #d3d3d3',
      marginRight: units(1),
      borderRadius: units(0.3),
      color: color.white,
      margin: units(0.3),
      fontSize: units(1),
      width: 'fit-content',
      cursor: 'default'
    },
    box_medium: {
      padding: units(0.8)
    },
    box_small: {
      padding: units(0.5)
    },
    box_micro: {
      padding: units(0.4)
    },
    box_large: {
      padding: units(1)
    },
    squareBox: {
      borderRadius: 0
    },
    others: {
      borderRadius: radius,
      cursor: 'pointer',
      marginLeft: units(0.8)
    }
  };
})(BoxGroup);
var _default = BoxGroupWithStyles;
exports.default = _default;